commit 70f560fc22212f733647c9121c26bbb2307f2e10
Author: Stafford Horne <shorne@gmail.com>
Date:   Wed Apr 3 06:40:37 2024 +0100

    misc: Add support for Linux uio.h RWF_NOAPPEND flag
    
    In Linux 6.9 a new flag is added to allow for Per-io operations to
    disable append mode even if a file was opened with the flag O_APPEND.
    This is done with the new RWF_NOAPPEND flag.
    
    This caused two test failures as these tests expected the flag 0x00000020
    to be unused.  Adding the flag definition now fixes these tests on Linux
    6.9 (v6.9-rc1).
    
      FAIL: misc/tst-preadvwritev2
      FAIL: misc/tst-preadvwritev64v2
    
    This patch adds the flag, adjusts the test and adds details to
    documentation.
    
    Link: https://lore.kernel.org/all/20200831153207.GO3265@brightrain.aerifal.cx/
    Reviewed-by: Adhemerval Zanella  <adhemerval.zanella@linaro.org>
    (cherry picked from commit 3db9d208dd5f30b12900989c6d2214782b8e2011)

diff --git a/misc/tst-preadvwritev2-common.c b/misc/tst-preadvwritev2-common.c
index b5f19f002c..8e04ff7282 100644
--- a/misc/tst-preadvwritev2-common.c
+++ b/misc/tst-preadvwritev2-common.c
@@ -34,8 +34,11 @@
 #ifndef RWF_APPEND
 # define RWF_APPEND 0
 #endif
+#ifndef RWF_NOAPPEND
+# define RWF_NOAPPEND 0
+#endif
 #define RWF_SUPPORTED	(RWF_HIPRI | RWF_DSYNC | RWF_SYNC | RWF_NOWAIT \
-			 | RWF_APPEND)
+			 | RWF_APPEND | RWF_NOAPPEND)
 
 /* Generic uio_lim.h does not define IOV_MAX.  */
 #ifndef IOV_MAX
diff --git a/sysdeps/unix/sysv/linux/bits/uio-ext.h b/sysdeps/unix/sysv/linux/bits/uio-ext.h
index 7854cccef3..ead7a09156 100644
--- a/sysdeps/unix/sysv/linux/bits/uio-ext.h
+++ b/sysdeps/unix/sysv/linux/bits/uio-ext.h
@@ -47,6 +47,7 @@ extern ssize_t process_vm_writev (pid_t __pid, const struct iovec *__lvec,
 #define RWF_SYNC	0x00000004 /* per-IO O_SYNC.  */
 #define RWF_NOWAIT	0x00000008 /* per-IO nonblocking mode.  */
 #define RWF_APPEND	0x00000010 /* per-IO O_APPEND.  */
+#define RWF_NOAPPEND	0x00000020 /* per-IO negation of O_APPEND */
 
 __END_DECLS
 

